Debian Bug report logs - #470882
gpm freezes and makes other applications freeze/segfault

version graph

Package: gpm; Maintainer for gpm is Peter Samuelson <peter@p12n.org>; Source for gpm is src:gpm.

Reported by: Gerfried Fuchs <rhonda@debian.at>

Date: Fri, 14 Mar 2008 09:48:04 UTC

Severity: grave

Tags: patch

Merged with 476431

Found in versions gpm-1.19.6-19sarge, gpm/1.20.3~pre3-3

Fixed in version gpm/1.20.4-3.1

Done: Neil Williams <codehelp@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. Full text and rfc822 format available.

Acknowledgement sent to Gerfried Fuchs <rhonda@debian.at>:
New Bug report received and forwarded. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Gerfried Fuchs <rhonda@debian.at>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: gpm freezes and makes other applications freeze/segfault
Date: Fri, 14 Mar 2008 10:45:35 +0100
Package: gpm
Version: 1.20.3~pre3-3
Severity: grave
Justification: renders package unusable

        Hi!

 Since yesterdays update of gpm in testing from 1.19.6-25 to
1.20.3~pre3-3 gpm regulary froze on me, making at least w3m, aptitude
and pdmenu freeze or even segfault - not even ctrl-c was possible
anymore when they froze.

 I /think/ that after the upgrade I only got frozen applications which
worked for a while again after a /etc/init.d/gpm restart (until I
completely stopped it), after a reboot today I even got segfaults in
them, mostly when I did put my powerbook to sleep and resumed.

 Stopping gpm made the problems go away completely. If I can be of
further help for tracking the issue down (like debug install?) don't
hesitate to tell me. I'm not yet sure how to relyable reproduce it, but
it happened regularly enough the last day that I consider this bugreport
and its severity justified.

 Thanks,
Rhonda

-- System Information:
Debian Release: lenny/sid
  APT prefers testing
  APT policy: (500, 'testing')
Architecture: powerpc (ppc)

Kernel: Linux 2.6.22-3-powerpc
Locale: LANG=de_AT.UTF-8, LC_CTYPE=de_AT.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages gpm depends on:
ii  debconf [debconf-2.0]      1.5.19        Debian configuration management sy
ii  debianutils                2.28.4        Miscellaneous utilities specific t
ii  libc6                      2.7-6         GNU C Library: Shared libraries
ii  libgpmg1                   1.20.3~pre3-3 General Purpose Mouse - shared lib
ii  lsb-base                   3.1-24        Linux Standard Base 3.1 init scrip
ii  ucf                        3.005         Update Configuration File: preserv

gpm recommends no packages.

-- debconf information:
* gpm/responsiveness:
* gpm/repeat_type: none
* gpm/append:
  gpm/restart: false
* gpm/sample_rate:
* gpm/type: exps2
* gpm/device: /dev/input/mice




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. Full text and rfc822 format available.

Acknowledgement sent to Gerfried Fuchs <rhonda@deb.at>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #10 received at 470882@bugs.debian.org (full text, mbox):

From: Gerfried Fuchs <rhonda@deb.at>
To: 470882@bugs.debian.org
Subject: Re: Bug#470882: gpm freezes and makes other applications freeze/segfault
Date: Fri, 14 Mar 2008 13:28:50 +0100
On Fri, Mar 14, 2008 at 10:45:35AM +0100, Gerfried Fuchs wrote:
>  Since yesterdays update of gpm in testing from 1.19.6-25 to
> 1.20.3~pre3-3 gpm regulary froze on me, making at least w3m, aptitude
> and pdmenu freeze or even segfault - not even ctrl-c was possible
> anymore when they froze.

 I have the situation right now again, here is the output from some
strace on the running gpm process that loops over and over again:

#v+
...
open("/dev/tty0", O_RDONLY)             = 4
fstat64(4, {st_mode=S_IFCHR|0660, st_rdev=makedev(4, 0), ...}) = 0
ioctl(4, KDGETMODE, 0x7fd666ec)         = 0
close(4)                                = 0
rt_sigprocmask(SIG_BLOCK, [CHLD], [], 8) = 0
rt_sigaction(SIGCHLD, NULL, {SIG_DFL}, 8) = 0
rt_sigprocmask(SIG_SETMASK, [], NULL, 8) = 0
nanosleep({2, 0}, {2, 0})               = 0
...
#v-

 I am not sure if it is really relevant or helpful, output of ls -l in
the /proc/$gpm_pid/fd directory:

#v+
lrwx------ 1 root root 64 2008-03-14 13:24 0 -> /dev/pts/2 (deleted)
lrwx------ 1 root root 64 2008-03-14 13:24 1 -> /dev/pts/2 (deleted)
lrwx------ 1 root root 64 2008-03-14 13:24 2 -> /dev/pts/2 (deleted)
lrwx------ 1 root root 64 2008-03-14 13:24 3 -> socket:[151652]
lrwx------ 1 root root 64 2008-03-14 13:24 5 -> socket:[151667]
#v-

 And here the output of lsof grepping for $gpm_pid:

#v+
gpm       19375        root  cwd       DIR        3,4     4096          2 /
gpm       19375        root  rtd       DIR        3,4     4096          2 /
gpm       19375        root  txt       REG        3,4    97520     332727 /usr/sbin/gpm
gpm       19375        root  mem       REG        3,4  1441900    1030304 /lib/libc-2.7.so
gpm       19375        root  mem       REG        3,4   682288    1030501 /lib/libm-2.7.so
gpm       19375        root  mem       REG        3,4   133708    1030233 /lib/ld-2.7.so
gpm       19375        root    0u      CHR      136,2                   4 /dev/pts/2 (deleted)
gpm       19375        root    1u      CHR      136,2                   4 /dev/pts/2 (deleted)
gpm       19375        root    2u      CHR      136,2                   4 /dev/pts/2 (deleted)
gpm       19375        root    3u     unix 0xec3c2c80              151652 socket
gpm       19375        root    5u     unix 0xec3c2800              151667 /dev/gpmctl
#v-

 I'm back to stopping gpm again for the time being.
Rhonda




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. Full text and rfc822 format available.

Acknowledgement sent to Vaclav Ovsik <vaclav.ovsik@i.cz>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #15 received at 470882@bugs.debian.org (full text, mbox):

From: Vaclav Ovsik <vaclav.ovsik@i.cz>
To: Debian Bug Tracking System <470882@bugs.debian.org>
Subject: /dev/gpmctl freezes acknowledge
Date: Wed, 30 Apr 2008 08:36:42 +0200
Package: gpm
Version: 1.20.3~pre3-3
Followup-For: Bug #470882

Hi,
I have this problem on my box and another two boxes at home too. Gpm
enabled applications freezes on communication with gpm. When I switch to
the console to see if mouse is functional under gpm right now (aptitude
hangs in rxvt) - mouse moves ok in text console.
Applications (aptitude, module-assistant,...) revive after gpm restart.
This problem appears several times a day for me.

It is sufficient to enter/quit aptitude or m-a six times (perhaps
exactly six times!) and problem arises (I check this several times with
aptitude now). Seventh enter is lockup. When I leave locked aptitude in
rxvt, switch to the text console, move around mouse a moment, go back
into the X-Window, aptitude revives.

Best Regards
-- 
Zito


-- System Information:
Debian Release: lenny/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: i386 (i686)

Kernel: Linux 2.6.24-1-686 (SMP w/2 CPU cores)
Locale: LANG=C, LC_CTYPE=cs_CZ.ISO-8859-2 (charmap=ISO-8859-2)
Shell: /bin/sh linked to /bin/bash

Versions of packages gpm depends on:
ii  debconf [debconf-2.0]      1.5.21        Debian configuration management sy
ii  debianutils                2.28.5        Miscellaneous utilities specific t
ii  libc6                      2.7-10        GNU C Library: Shared libraries
ii  libgpmg1                   1.20.3~pre3-3 General Purpose Mouse - shared lib
ii  lsb-base                   3.2-11        Linux Standard Base 3.2 init scrip
ii  ucf                        3.006         Update Configuration File: preserv

gpm recommends no packages.

-- debconf information:
* gpm/responsiveness: 16
* gpm/repeat_type:
* gpm/append: -S ""
* gpm/restart: false
* gpm/sample_rate:
* gpm/type: imps2
* gpm/device: /dev/input/mice
* gpm/restart_default: false




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. Full text and rfc822 format available.

Acknowledgement sent to Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #20 received at 470882@bugs.debian.org (full text, mbox):

From: Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
To: Vaclav Ovsik <vaclav.ovsik@i.cz>
Cc: Debian Bug Tracking System <470882@bugs.debian.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Wed, 30 Apr 2008 13:35:51 +0200
[Message part 1 (text/plain, inline)]
Hello!

Vaclav Ovsik [Wed, Apr 30, 2008 at 08:36:42AM +0200]:
> Hi,
> I have this problem on my box and another two boxes at home too. Gpm
> enabled applications freezes on communication with gpm. When I switch to
> the console to see if mouse is functional under gpm right now (aptitude
> hangs in rxvt) - mouse moves ok in text console.
> Applications (aptitude, module-assistant,...) revive after gpm restart.
> This problem appears several times a day for me.

Can you do strace -Ff <program> 2> log before starting the program that
hangs?

And can you run gpm -D <options> >gpm.log 2>&1 on another console before?

And then send both files to me?

Nico

-- 
Think about Free and Open Source Software (FOSS).
http://nico.schottelius.org/documentations/foss/the-term-foss/

PGP: BFE4 C736 ABE5 406F 8F42  F7CF B8BE F92A 9885 188C
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. Full text and rfc822 format available.

Acknowledgement sent to Václav Ovsík <vaclav.ovsik@i.cz>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #25 received at 470882@bugs.debian.org (full text, mbox):

From: Václav Ovsík <vaclav.ovsik@i.cz>
To: Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Cc: Debian Bug Tracking System <470882@bugs.debian.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Wed, 30 Apr 2008 14:40:26 +0200
[Message part 1 (text/plain, inline)]
On Wed, Apr 30, 2008 at 01:35:51PM +0200, Nico Schottelius wrote:
> Hello!
> 
> Vaclav Ovsik [Wed, Apr 30, 2008 at 08:36:42AM +0200]:
> > Hi,
> > I have this problem on my box and another two boxes at home too. Gpm
> > enabled applications freezes on communication with gpm. When I switch to
> > the console to see if mouse is functional under gpm right now (aptitude
> > hangs in rxvt) - mouse moves ok in text console.
> > Applications (aptitude, module-assistant,...) revive after gpm restart.
> > This problem appears several times a day for me.
> 
> Can you do strace -Ff <program> 2> log before starting the program that
> hangs?
> 
> And can you run gpm -D <options> >gpm.log 2>&1 on another console before?
> 
> And then send both files to me?

Of course.

bobek:~# /usr/sbin/gpm -m /dev/input/mice -t imps2 -r 16 -D &>gpm.log

# six times aptitude ran

# seventh aptitude run as you requested:

zito@bobek:~$ strace -Ff aptitude 2>aptitude-gpm.log

# The screen stayed black, so I did a copy of both log files
# with `.1' in the filename.

# I switched into the text console, did some mouse moves, switched
# back into X-Window, quit already running aptitude and Ctrl-C the gpm.

After this I ran the gpm again with the gpm2.log and ran aptitude only
two times, did moves on the text console and interrupted (Ctrl-C) the gpm.
Messages about failed connections from gpm appeared in the log file
until mouse moves on text console.

Log files are attached.

Regards
-- 
Zito
[gpm.1.log (text/plain, attachment)]
[gpm.log.bz2 (application/octet-stream, attachment)]
[aptitude-gpm.log.bz2 (application/octet-stream, attachment)]
[aptitude-gpm.1.log.bz2 (application/octet-stream, attachment)]
[gpm2.log.bz2 (application/octet-stream, attachment)]

Forcibly Merged 412927 470882 473496 476431. Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Wed, 11 Jun 2008 05:48:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #32 received at 470882@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: control@bugs.debian.org
Cc: 412927@bugs.debian.org, 470882@bugs.debian.org, 472062@bugs.debian.org, 473496@bugs.debian.org, 474516@bugs.debian.org, 476431@bugs.debian.org, 479345@bugs.debian.org, 482138@bugs.debian.org, 483916@bugs.debian.org
Subject: setting package to gpm libgpm-dev libgpmg1-dev libgpm2, tagging 470882, tagging 476431 ...
Date: Wed, 11 Jun 2008 09:33:11 +0300
# Automatically generated email from bts, devscripts version 2.10.29
#
# gpm (1.20.4-1) UNRELEASED; urgency=low
#
#  * New upstream version. (Closes: #482138)
#    - debian/patches/001_logging.patch: Removed, merged upstream.
#    - debian/patches/006_version_000: Likewise.
#    - debian/patches/008_sun_repeat_000: Likewise.
#    - debian/patches/030_segfault: Likewise.
#    - debian/patches/001_missing_V_option.patch: Refresh.
#    - debian/patches/002_force_repeat_000: Likewise.
#    - debian/patches/005_types_000: Likewise.
#    - debian/patches/007_doc_fix_000: Likewise.
#    - debian/patches/010_ps2_rework.patch: Likewise.
#    - debian/patches/013_xterm_mouse_support_000: Likewise.
#    - debian/patches/015_libgpm_noverbose.patch: Likewise.
#    - debian/patches/030_daemon_quit: Likewise.
#    - debian/patches/040_no_OPEN_MAX.patch: Likewise.
#    - debian/patches/050_dont_link_libcurses: Likewise.
#    - debian/rules: Fix Changelog to Changes in dh_installchangelogs call.
#    - Properly cleanup on 'make clean', fixes building twice in a row.
#      (Closes: 479345)
#    - Support default gpm handlers again. (Closes: #472062)
#    - Do not log 'Connecting' and 'Request' messages on syslog.
#      (Closes: #474516)
#  * Debian broke ABI compatibility with upstream long time ago, the patch
#    got merged upstream recently but the new field was added in a different
#    place in the structure. With the new 1.20.3~pre3 release Debian had
#    to be either incompatible with previous Debian gpm versions or with
#    upstream again, but quite helpfully upstream bumped the SONAME.
#    (Closes: #412927, #470882, #473496, #476431)
#    - Add a new libgpm2 and libgpm-dev packages.
#    - Remove the libgpmg1 package.
#    - Make the libgpmg1-dev a dummy package to ease the transition.
#    - Remove old Conflicts and Replaces on libgpm1.
#    - Bump libgpm shlibs dependency to 1.20.4.
#  * Italian, thanks David Paleino.  (Closes: #483916) 

package gpm libgpm-dev libgpmg1-dev libgpm2
tags 470882 + pending
tags 476431 + pending
tags 412927 + pending
tags 483916 + pending
tags 479345 + pending
tags 482138 + pending
tags 474516 + pending
tags 472062 + pending
tags 473496 + pending





Tags added: pending Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Wed, 11 Jun 2008 06:36:15 GMT) Full text and rfc822 format available.

Tags added: pending Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Wed, 11 Jun 2008 06:36:19 GMT) Full text and rfc822 format available.

Tags added: pending Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Wed, 11 Jun 2008 06:36:21 GMT) Full text and rfc822 format available.

Tags added: pending Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Wed, 11 Jun 2008 06:36:28 GMT) Full text and rfc822 format available.

Tags added: pending Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. (Thu, 12 Jun 2008 10:51:14 GMT) Full text and rfc822 format available.

Tags added: pending Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. (Thu, 12 Jun 2008 10:51:16 GMT) Full text and rfc822 format available.

Tags added: pending Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. (Thu, 12 Jun 2008 10:51:20 GMT) Full text and rfc822 format available.

Tags added: pending Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. (Thu, 12 Jun 2008 10:51:23 GMT) Full text and rfc822 format available.

Reply sent to Guillem Jover <guillem@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Gerfried Fuchs <rhonda@debian.at>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #53 received at 470882-close@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 470882-close@bugs.debian.org
Subject: Bug#470882: fixed in gpm 1.20.4-1
Date: Sun, 15 Jun 2008 15:29:26 +0000
Source: gpm
Source-Version: 1.20.4-1

We believe that the bug you reported is fixed in the latest version of
gpm, which is due to be installed in the Debian FTP archive:

gpm_1.20.4-1.diff.gz
  to pool/main/g/gpm/gpm_1.20.4-1.diff.gz
gpm_1.20.4-1.dsc
  to pool/main/g/gpm/gpm_1.20.4-1.dsc
gpm_1.20.4-1_i386.deb
  to pool/main/g/gpm/gpm_1.20.4-1_i386.deb
gpm_1.20.4.orig.tar.gz
  to pool/main/g/gpm/gpm_1.20.4.orig.tar.gz
libgpm-dev_1.20.4-1_i386.deb
  to pool/main/g/gpm/libgpm-dev_1.20.4-1_i386.deb
libgpm2_1.20.4-1_i386.deb
  to pool/main/g/gpm/libgpm2_1.20.4-1_i386.deb
libgpmg1-dev_1.20.4-1_i386.deb
  to pool/main/g/gpm/libgpmg1-dev_1.20.4-1_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 470882@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Guillem Jover <guillem@debian.org> (supplier of updated gpm package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Wed, 11 Jun 2008 09:30:31 +0300
Source: gpm
Binary: gpm libgpm2 libgpm-dev libgpmg1-dev
Architecture: source i386
Version: 1.20.4-1
Distribution: experimental
Urgency: low
Maintainer: Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>
Changed-By: Guillem Jover <guillem@debian.org>
Description: 
 gpm        - General Purpose Mouse interface
 libgpm-dev - General Purpose Mouse - development files
 libgpm2    - General Purpose Mouse - shared library
 libgpmg1-dev - transitional dummy package which can be safely removed
Closes: 412927 470882 472062 473496 474516 476431 479345 482138 483916
Changes: 
 gpm (1.20.4-1) experimental; urgency=low
 .
   [ Guillem Jover ]
   * New upstream version. (Closes: #482138)
     - debian/patches/001_logging.patch: Removed, merged upstream.
     - debian/patches/006_version_000: Likewise.
     - debian/patches/008_sun_repeat_000: Likewise.
     - debian/patches/030_segfault: Likewise.
     - debian/patches/001_missing_V_option.patch: Refresh.
     - debian/patches/002_force_repeat_000: Likewise.
     - debian/patches/005_types_000: Likewise.
     - debian/patches/007_doc_fix_000: Likewise.
     - debian/patches/010_ps2_rework.patch: Likewise.
     - debian/patches/013_xterm_mouse_support_000: Likewise.
     - debian/patches/015_libgpm_noverbose.patch: Likewise.
     - debian/patches/030_daemon_quit: Likewise.
     - debian/patches/040_no_OPEN_MAX.patch: Likewise.
     - debian/patches/050_dont_link_libcurses: Likewise.
     - debian/rules: Fix Changelog to Changes in dh_installchangelogs call.
     - Properly cleanup on 'make clean', fixes building twice in a row.
       (Closes: 479345)
     - Support default gpm handlers again. (Closes: #472062)
     - Do not log 'Connecting' and 'Request' messages on syslog.
       (Closes: #474516)
   * Debian broke ABI compatibility with upstream long time ago, the patch
     got merged upstream recently but the new field was added in a different
     place in the structure. With the new 1.20.3~pre3 release Debian had
     to be either incompatible with previous Debian gpm versions or with
     upstream again, but quite helpfully upstream bumped the SONAME.
     (Closes: #412927, #470882, #473496, #476431)
     - Add a new libgpm2 and libgpm-dev packages.
     - Remove the libgpmg1 package.
     - Make the libgpmg1-dev a dummy package to ease the transition.
     - Remove old Conflicts and Replaces on libgpm1.
     - Bump libgpm shlibs dependency to 1.20.4.
   * Switch to use dh_lintian instead of manually installing the overrides.
     Bump the versioned debhelper Build-Depends to 6.0.7.
   * Remove now unused gpm lintian overrides, and add one for libgpmg1-dev.
   * Fix parallel FTBFS in debian/rules by moving 'patch' dependency from
     the build to a new pre-patch target that serializes configuration.
   * Add a debian/README.source file.
   * Now using Standards-Version 3.8.0.
 .
   [ Peter Samuelson ]
   * New debconf translations:
     - Italian, thanks David Paleino.  (Closes: #483916)
Checksums-Sha1: 
 b3701fcd3afcdd19777d240e3927def0f46ac54c 1283 gpm_1.20.4-1.dsc
 5a16db5e4dc39fbf3c53a09d1460ca468ef1af44 1347133 gpm_1.20.4.orig.tar.gz
 6bf3fbeb1d991e2c2da121124a6b0c798ba72ac4 84127 gpm_1.20.4-1.diff.gz
 fa131748b283c7f6fdfc340463631215079679ac 210658 gpm_1.20.4-1_i386.deb
 375741d5bc2bb4ed4c5f7dba8ad4f6502a74b3bf 32950 libgpm2_1.20.4-1_i386.deb
 d3456adc01b326bcc7a6dba8d20655bde17aacba 35950 libgpm-dev_1.20.4-1_i386.deb
 ecc7d3b2238d8d71fc4ef7fa058e0f50bc9cfd74 22958 libgpmg1-dev_1.20.4-1_i386.deb
Checksums-Sha256: 
 32fc370e0c1baec1be59161507bf094e9bdd7a40c1f3d2443cfb8f5a1904fdf3 1283 gpm_1.20.4-1.dsc
 d6c87cd0f2c32e2c3435c444728f2ae60324fda60dedda783ea0f24f363e576c 1347133 gpm_1.20.4.orig.tar.gz
 94b7daa49307b12de12b87da832088735f403cfb58bef4e1f2a0be51ad8ec72c 84127 gpm_1.20.4-1.diff.gz
 3e425cacfb57b766e1c9d6b3af8f502d7e010838e65476cfd57e2a1b6daecead 210658 gpm_1.20.4-1_i386.deb
 06559ae50699ad309189aa35448c44e776f44447be24da51a01cd3b7ac54100b 32950 libgpm2_1.20.4-1_i386.deb
 976240f29a2676e4ac7dfd006673fdce4f3f67fc66ec61a859d6f9a6e59f3a58 35950 libgpm-dev_1.20.4-1_i386.deb
 158350780d2b2e0cb6c3a4e4fe98bc1b33e675e0c8e1f816e44726cd94b03f8d 22958 libgpmg1-dev_1.20.4-1_i386.deb
Files: 
 03cc9711888d250fb3125d8c30d137f1 1283 misc optional gpm_1.20.4-1.dsc
 ac31dbe9ff294720acf4fc9328b60e22 1347133 misc optional gpm_1.20.4.orig.tar.gz
 458ff87ab66527e23df1e3a533418f03 84127 misc optional gpm_1.20.4-1.diff.gz
 e6a5fef1f85cd9782be3ec2f70097e7a 210658 misc optional gpm_1.20.4-1_i386.deb
 952a1fa0adc0cd06f8eb84911bb2fb51 32950 libs standard libgpm2_1.20.4-1_i386.deb
 da9e11223955affdd42ef159fd416801 35950 libdevel optional libgpm-dev_1.20.4-1_i386.deb
 eaf21a235f0398251f948871855ac668 22958 oldlibs extra libgpmg1-dev_1.20.4-1_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkhPclMACgkQuW9ciZ2SjJv90wCeNM6AITehFZkDCnimZd8ODTTp
YC8AoORxorddgAimMBaWKMsYBawlwNCA
=BNzL
-----END PGP SIGNATURE-----





Reply sent to Guillem Jover <guillem@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Daniël Mantione <daniel.mantione@freepascal.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Reply sent to Guillem Jover <guillem@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Kevin Ryde <user42@zip.com.au>:
Bug acknowledged by developer. Full text and rfc822 format available.

Reply sent to Guillem Jover <guillem@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Simon Raven <simon.raven@gmail.com>:
Bug acknowledged by developer. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. Full text and rfc822 format available.

Acknowledgement sent to Gerfried Fuchs <rhonda@deb.at>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #73 received at 470882@bugs.debian.org (full text, mbox):

From: Gerfried Fuchs <rhonda@deb.at>
To: 470882@bugs.debian.org
Cc: control@bugs.debian.org
Subject: Re: Bug#470882 closed by Guillem Jover <guillem@debian.org> (Bug#470882: fixed in gpm 1.20.4-1)
Date: Wed, 25 Jun 2008 10:07:22 +0200
reopen 470882
thanks

* Debian Bug Tracking System <owner@bugs.debian.org> [2008-06-25 08:02:34 CEST]:
>    * Debian broke ABI compatibility with upstream long time ago, the patch
>      got merged upstream recently but the new field was added in a different
>      place in the structure. With the new 1.20.3~pre3 release Debian had
>      to be either incompatible with previous Debian gpm versions or with
>      upstream again, but quite helpfully upstream bumped the SONAME.
>      (Closes: #412927, #470882, #473496, #476431)

 Unfortunately the ABI compatibility doesn't seem to be the cause for
the problem I reported:

|  Since yesterdays update of gpm in testing from 1.19.6-25 to
| 1.20.3~pre3-3 gpm regulary froze on me, making at least w3m, aptitude
| and pdmenu freeze or even segfault - not even ctrl-c was possible
| anymore when they froze.
| 
|  I /think/ that after the upgrade I only got frozen applications which
| worked for a while again after a /etc/init.d/gpm restart (until I
| completely stopped it), after a reboot today I even got segfaults in
| them, mostly when I did put my powerbook to sleep and resumed.
| 
|  Stopping gpm made the problems go away completely. If I can be of
| further help for tracking the issue down (like debug install?) don't
| hesitate to tell me. I'm not yet sure how to relyable reproduce it, but
| it happened regularly enough the last day that I consider this bugreport
| and its severity justified.

 This problem is still existent after the upgrade to the new version of
gpm from unstable (including the binNMUs for w3m and pdmenu), so I can't
call this problem fixed, sorry.

 So long,
Rhonda




Bug reopened, originator not changed. Request was from Gerfried Fuchs <rhonda@deb.at> to control@bugs.debian.org. (Wed, 25 Jun 2008 08:45:17 GMT) Full text and rfc822 format available.

Bug reopened, originator not changed. Request was from Paul Wise <pabs@debian.org> to control@bugs.debian.org. (Thu, 04 Sep 2008 04:21:03 GMT) Full text and rfc822 format available.

Disconnected #470882 from all other report(s). Request was from Samuel Thibault <samuel.thibault@ens-lyon.org> to control@bugs.debian.org. (Tue, 07 Oct 2008 20:33:17 GMT) Full text and rfc822 format available.

Forcibly Merged 470882 476431. Request was from Samuel Thibault <samuel.thibault@ens-lyon.org> to control@bugs.debian.org. (Wed, 08 Oct 2008 17:39:06 GMT) Full text and rfc822 format available.

Disconnected #476431 from all other report(s). Request was from Gerfried Fuchs <rhonda@debian.at> to control@bugs.debian.org. (Wed, 08 Oct 2008 21:21:06 GMT) Full text and rfc822 format available.

Forcibly Merged 470882 476431. Request was from Gerfried Fuchs <rhonda@debian.at> to control@bugs.debian.org. (Wed, 08 Oct 2008 21:21:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Wed, 08 Oct 2008 23:15:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <samuel.thibault@ens-lyon.org>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Wed, 08 Oct 2008 23:15:05 GMT) Full text and rfc822 format available.

Message #90 received at 470882@bugs.debian.org (full text, mbox):

From: Samuel Thibault <samuel.thibault@ens-lyon.org>
To: Václav Ovsík <vaclav.ovsik@i.cz>, 470882@bugs.debian.org, Thomas Dickey <dickey@radix.net>
Cc: Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Thu, 9 Oct 2008 01:14:28 +0200
Just to summarize a few things:

- apparently it happens just for clients run in an terminal in X.
- the server logs previously attached to the bug show
"Failed gpm connect attempt by uid 1000 for vc /dev/tty0"
which means that libgpm tried to connect to the gpm server, and failed
since it didn't know which VT to acquire, thus tried tty0, and failed
since it probably belongs to root, not to uid 1000.

I tried to reproduce that, and I noticed something in the strace I could
get: 

# the client logs the connection error
sendto(52, "<14>Oct  9 00:55:37 aptitude: *** info", 39, MSG_NOSIGNAL, NULL, 0) = 39
sendto(52, "<14>Oct  9 00:55:37 aptitude: Warning: closing connection", 57, MSG_NOSIGNAL, NULL, 0) = 57
# closes the socket
close(4)    
...
# and still tries to select it!
select(5, [0 4], NULL, NULL, {0, 166000}) = -1 EBADF (Bad file descriptor)

it looks like the caller of libgpm didn't notice that gpm_fd is not
a valid file descriptor any more.  In the case of aptitude, that's
ncurses...  Thomas?

Now, that being said, that reminds me bug #472063: actually libgpm
shouldn't even have tried to connect to the server, it should have just
noticed it is running in an X terminal and set gpm_fd to -2...

Samuel




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Thu, 09 Oct 2008 00:03:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@radix.net>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Thu, 09 Oct 2008 00:03:02 GMT) Full text and rfc822 format available.

Message #95 received at 470882@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Samuel Thibault <samuel.thibault@ens-lyon.org>
Cc: Václav Ovsík <vaclav.ovsik@i.cz>, 470882@bugs.debian.org, Thomas Dickey <dickey@radix.net>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Wed, 8 Oct 2008 20:00:32 -0400
[Message part 1 (text/plain, inline)]
On Thu, Oct 09, 2008 at 01:14:28AM +0200, Samuel Thibault wrote:
> Just to summarize a few things:

recap - there's more than one client scenario:

	a) w3m, the last I looked, was abusing ncurses interface to
	   access gpm in its own way.  I'll keep in mind to not break
	   it, but its usage is completely unsupported.

	b) I'm not as familiar with pdmenu source - but reading, seems to
	   talk directly to gpm using its documented interface, and to
	   be using slang.

	c) aptitude is using ncurses via cwidgets (this might be mine ;-)
 
> - apparently it happens just for clients run in an terminal in X.
> - the server logs previously attached to the bug show
> "Failed gpm connect attempt by uid 1000 for vc /dev/tty0"
> which means that libgpm tried to connect to the gpm server, and failed
> since it didn't know which VT to acquire, thus tried tty0, and failed
> since it probably belongs to root, not to uid 1000.
> 
> I tried to reproduce that, and I noticed something in the strace I could
> get: 
> 
> # the client logs the connection error
> sendto(52, "<14>Oct  9 00:55:37 aptitude: *** info", 39, MSG_NOSIGNAL, NULL, 0) = 39
> sendto(52, "<14>Oct  9 00:55:37 aptitude: Warning: closing connection", 57, MSG_NOSIGNAL, NULL, 0) = 57
> # closes the socket
> close(4)    
> ...
> # and still tries to select it!
> select(5, [0 4], NULL, NULL, {0, 166000}) = -1 EBADF (Bad file descriptor)
> 
> it looks like the caller of libgpm didn't notice that gpm_fd is not
> a valid file descriptor any more.  In the case of aptitude, that's
> ncurses...  Thomas?
> 
> Now, that being said, that reminds me bug #472063: actually libgpm
> shouldn't even have tried to connect to the server, it should have just
> noticed it is running in an X terminal and set gpm_fd to -2...

With the latest update, ncurses won't try to use gpm if $TERM doesn't
contain "linux", unless it's overridden (with a new environment variable).

Before the immediate changes of the past month - ncurses would try to
use gpm - and I agree that it should have failed since I'd expect gpm_fd
to be returned as a negative value.  That check is made in one place in
lib_mouse.c:

        result = (my_Gpm_Open(&SP->_mouse_gpm_connect, 0) >= 0);

I noticed that for some reason it was _not_ failing, when the gpm server was
running, but did not dig into the gpm package (just examined the source code
w/o seeing the problem).  As I recall it, ncurses did both checks because
some previous users insisted that gpm works in xterm.

But that issue prompted me to add the additional restriction, to move
away from gpm a little further.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Thu, 09 Oct 2008 22:24:25 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <samuel.thibault@ens-lyon.org>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Thu, 09 Oct 2008 22:24:26 GMT) Full text and rfc822 format available.

Message #100 received at 470882@bugs.debian.org (full text, mbox):

From: Samuel Thibault <samuel.thibault@ens-lyon.org>
To: Simon Raven <simon.raven@gmail.com>, Gerfried Fuchs <rhonda@debian.at>, Václav Ovsík <vaclav.ovsik@i.cz>
Cc: Thomas Dickey <dickey@radix.net>, 470882@bugs.debian.org, 476431@bugs.debian.org, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Thu, 9 Oct 2008 23:59:43 +0200
Thomas Dickey, le Wed 08 Oct 2008 20:00:32 -0400, a écrit :
> With the latest update, ncurses won't try to use gpm if $TERM doesn't
> contain "linux", unless it's overridden (with a new environment variable).

Ah, indeed.  Rhonda, Zito or Simon, could you check whether upgrading
your libncurses5 and libncursesw5 to 5.6+20081004-1 fixes the bug?  I
think that should fix it for the usual cases.

Samuel




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Fri, 10 Oct 2008 11:12:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Gerfried Fuchs <rhonda@deb.at>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Fri, 10 Oct 2008 11:12:05 GMT) Full text and rfc822 format available.

Message #105 received at 470882@bugs.debian.org (full text, mbox):

From: Gerfried Fuchs <rhonda@deb.at>
To: Samuel Thibault <samuel.thibault@ens-lyon.org>
Cc: Simon Raven <simon.raven@gmail.com>, Gerfried Fuchs <rhonda@debian.at>, Václav Ovsík <vaclav.ovsik@i.cz>, Thomas Dickey <dickey@radix.net>, 470882@bugs.debian.org, 476431@bugs.debian.org, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Fri, 10 Oct 2008 13:10:35 +0200
* Samuel Thibault <samuel.thibault@ens-lyon.org> [2008-10-09 23:59:43 CEST]:
> Thomas Dickey, le Wed 08 Oct 2008 20:00:32 -0400, a écrit :
> > With the latest update, ncurses won't try to use gpm if $TERM doesn't
> > contain "linux", unless it's overridden (with a new environment variable).
> 
> Ah, indeed.  Rhonda, Zito or Simon, could you check whether upgrading
> your libncurses5 and libncursesw5 to 5.6+20081004-1 fixes the bug?  I
> think that should fix it for the usual cases.

 These packages are currently installed:

w3m 0.5.2-2+b1, Versions of packages w3m depends on:
ii  libc6                  2.7-13            GNU C Library: Shared libraries
ii  libgc1c2               1:6.8-1.1         conservative garbage collector for
ii  libgpm2                1.20.4-2          General Purpose Mouse - shared lib
ii  libncurses5            5.6+20081004-1    shared libraries for terminal hand
ii  libssl0.9.8            0.9.8g-13         SSL shared libraries
ii  zlib1g                 1:1.2.3.3.dfsg-12 compression library - runtime

 Doesn't solve the issue, unfortunately. I've upgraded all my ncurses
packages, after that started gpm and did run and quit
'w3m http://nm.debian.org/' exactly seven times (reproducible), likewise
with pdmenu:

#v+
rhonda@edna:~$ sudo /etc/init.d/gpm start
Starting mouse interface server: gpm.
rhonda@edna:~$ pdmenu 
rhonda@edna:~$ pdmenu 
rhonda@edna:~$ pdmenu 
rhonda@edna:~$ pdmenu 
rhonda@edna:~$ pdmenu 
rhonda@edna:~$ pdmenu 
rhonda@edna:~$ pdmenu 
#v-

 Did press x and enter in the started pdmenu, the last one just hangs
and doesn't start until gpm is stopped again.

 Thanks for keeping an eye on it, if there's more I can do, just let me
know.

 So long,
Rhonda




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Fri, 10 Oct 2008 11:24:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <samuel.thibault@ens-lyon.org>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Fri, 10 Oct 2008 11:24:05 GMT) Full text and rfc822 format available.

Message #110 received at 470882@bugs.debian.org (full text, mbox):

From: Samuel Thibault <samuel.thibault@ens-lyon.org>
To: Gerfried Fuchs <rhonda@deb.at>
Cc: Simon Raven <simon.raven@gmail.com>, Gerfried Fuchs <rhonda@debian.at>, Václav Ovsík <vaclav.ovsik@i.cz>, Thomas Dickey <dickey@radix.net>, 470882@bugs.debian.org, 476431@bugs.debian.org, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Fri, 10 Oct 2008 13:21:49 +0200
Gerfried Fuchs, le Fri 10 Oct 2008 13:10:35 +0200, a écrit :
> ii  libncurses5            5.6+20081004-1    shared libraries for terminal hand
> 
>  Doesn't solve the issue, unfortunately.

Ok so you're encountering another bug than what I've noticed.  Am I
right in thinking that this only happens in an xterm, not on the text
console?

Samuel




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Fri, 10 Oct 2008 11:33:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@radix.net>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Fri, 10 Oct 2008 11:33:05 GMT) Full text and rfc822 format available.

Message #115 received at 470882@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Gerfried Fuchs <rhonda@deb.at>
Cc: Samuel Thibault <samuel.thibault@ens-lyon.org>, Simon Raven <simon.raven@gmail.com>, Gerfried Fuchs <rhonda@debian.at>, Václav Ovsík <vaclav.ovsik@i.cz>, Thomas Dickey <dickey@radix.net>, 470882@bugs.debian.org, 476431@bugs.debian.org, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Fri, 10 Oct 2008 07:30:18 -0400
[Message part 1 (text/plain, inline)]
On Fri, Oct 10, 2008 at 01:10:35PM +0200, Gerfried Fuchs wrote:
> * Samuel Thibault <samuel.thibault@ens-lyon.org> [2008-10-09 23:59:43 CEST]:
> > Thomas Dickey, le Wed 08 Oct 2008 20:00:32 -0400, a écrit :
> > > With the latest update, ncurses won't try to use gpm if $TERM doesn't
> > > contain "linux", unless it's overridden (with a new environment variable).
> > 
> > Ah, indeed.  Rhonda, Zito or Simon, could you check whether upgrading
> > your libncurses5 and libncursesw5 to 5.6+20081004-1 fixes the bug?  I
> > think that should fix it for the usual cases.
> 
>  These packages are currently installed:
> 
> w3m 0.5.2-2+b1, Versions of packages w3m depends on:

I already commented on w3m.  It's using names from ncurses without actually
using the ncurses library, to fool gpm into working by calling w3m's code.

See

  http://invisible-island.net/ncurses/ncurses.faq.html#using_gpm_lib

> ii  libc6                  2.7-13            GNU C Library: Shared libraries
> ii  libgc1c2               1:6.8-1.1         conservative garbage collector for
> ii  libgpm2                1.20.4-2          General Purpose Mouse - shared lib
> ii  libncurses5            5.6+20081004-1    shared libraries for terminal hand
> ii  libssl0.9.8            0.9.8g-13         SSL shared libraries
> ii  zlib1g                 1:1.2.3.3.dfsg-12 compression library - runtime
> 
>  Doesn't solve the issue, unfortunately. I've upgraded all my ncurses
> packages, after that started gpm and did run and quit
> 'w3m http://nm.debian.org/' exactly seven times (reproducible), likewise
> with pdmenu:

...Of the programs mentioned, ncurses updates should only affect aptitude.
pdmenu does not appear to rely on ncurses (see my first reply).

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Fri, 10 Oct 2008 11:54:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Gerfried Fuchs <rhonda@deb.at>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Fri, 10 Oct 2008 11:54:02 GMT) Full text and rfc822 format available.

Message #120 received at 470882@bugs.debian.org (full text, mbox):

From: Gerfried Fuchs <rhonda@deb.at>
To: Samuel Thibault <samuel.thibault@ens-lyon.org>
Cc: Simon Raven <simon.raven@gmail.com>, Václav Ovsík <vaclav.ovsik@i.cz>, Thomas Dickey <dickey@radix.net>, 470882@bugs.debian.org, 476431@bugs.debian.org, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Fri, 10 Oct 2008 13:50:47 +0200
* Samuel Thibault <samuel.thibault@ens-lyon.org> [2008-10-10 13:21:49 CEST]:
> Gerfried Fuchs, le Fri 10 Oct 2008 13:10:35 +0200, a écrit :
> > ii  libncurses5            5.6+20081004-1    shared libraries for terminal hand
> > 
> >  Doesn't solve the issue, unfortunately.
> 
> Ok so you're encountering another bug than what I've noticed.  Am I
> right in thinking that this only happens in an xterm, not on the text
> console?

 I'm using an rxvt-unicode, but yes. First time tried to test it in a
virtual console and indeed, the bug doesn't appear to happen there,
started pdmenu for at least 20 times without troubles.

 Did give it another test: When pdmenu hangs and switching from X11 to
virtual console and back, pdmenu displayed its menu, but pressing any
key will make it segfault from that state.

 So long,
Rhonda




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Fri, 10 Oct 2008 11:54:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Václav Ovsík <vaclav.ovsik@i.cz>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Fri, 10 Oct 2008 11:54:03 GMT) Full text and rfc822 format available.

Message #125 received at 470882@bugs.debian.org (full text, mbox):

From: Václav Ovsík <vaclav.ovsik@i.cz>
To: Samuel Thibault <samuel.thibault@ens-lyon.org>
Cc: Simon Raven <simon.raven@gmail.com>, Gerfried Fuchs <rhonda@debian.at>, Thomas Dickey <dickey@radix.net>, 470882@bugs.debian.org, 476431@bugs.debian.org, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Fri, 10 Oct 2008 13:51:32 +0200
On Thu, Oct 09, 2008 at 11:59:43PM +0200, Samuel Thibault wrote:
> Thomas Dickey, le Wed 08 Oct 2008 20:00:32 -0400, a écrit :
> > With the latest update, ncurses won't try to use gpm if $TERM doesn't
> > contain "linux", unless it's overridden (with a new environment variable).
> 
> Ah, indeed.  Rhonda, Zito or Simon, could you check whether upgrading
> your libncurses5 and libncursesw5 to 5.6+20081004-1 fixes the bug?  I
> think that should fix it for the usual cases.

Yes, upgrade solved my problem - aptitude, m-a at least.
I tried start these 10 times and freeze didn't occured.

I'm using Unicode Rxvt X terminal emulator.

zito@bobek:~$ echo $TERM
rxvt-unicode

I tested problem with 5.6+20080925-1 positively, than upgrade to
5.6+20081004-1 and it is OK now.

ii  libncurses5    5.6+20081004-1 shared libraries for terminal handling

Regards
-- 
Zito




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Fri, 10 Oct 2008 12:36:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Gerfried Fuchs <rhonda@deb.at>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Fri, 10 Oct 2008 12:36:02 GMT) Full text and rfc822 format available.

Message #130 received at 470882@bugs.debian.org (full text, mbox):

From: Gerfried Fuchs <rhonda@deb.at>
To: Thomas Dickey <dickey@radix.net>
Cc: Samuel Thibault <samuel.thibault@ens-lyon.org>, Simon Raven <simon.raven@gmail.com>, Gerfried Fuchs <rhonda@debian.at>, Václav Ovsík <vaclav.ovsik@i.cz>, 470882@bugs.debian.org, 476431@bugs.debian.org, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Fri, 10 Oct 2008 14:34:14 +0200
* Thomas Dickey <dickey@radix.net> [2008-10-10 13:30:18 CEST]:
> On Fri, Oct 10, 2008 at 01:10:35PM +0200, Gerfried Fuchs wrote:
> > w3m 0.5.2-2+b1, Versions of packages w3m depends on:
> 
> I already commented on w3m.  It's using names from ncurses without actually
> using the ncurses library, to fool gpm into working by calling w3m's code.

 Ah, sorry.

> ...Of the programs mentioned, ncurses updates should only affect aptitude.
> pdmenu does not appear to rely on ncurses (see my first reply).

 Hanging pdmenu doesn't affect aptitude usage. I'm currently downgrading
ncurses5 again to test wether that is really an improvement, wasn't sure
how it was before that.

 Yes, downgrading ncurses5 makes aptitude hang, too.

 So long,
Rhonda




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Fri, 10 Oct 2008 23:06:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <samuel.thibault@ens-lyon.org>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Fri, 10 Oct 2008 23:06:02 GMT) Full text and rfc822 format available.

Message #135 received at 470882@bugs.debian.org (full text, mbox):

From: Samuel Thibault <samuel.thibault@ens-lyon.org>
To: Thomas Dickey <dickey@radix.net>
Cc: Václav Ovsík <vaclav.ovsik@i.cz>, 470882@bugs.debian.org, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Sat, 11 Oct 2008 01:02:30 +0200
Thomas Dickey, le Wed 08 Oct 2008 20:00:32 -0400, a écrit :
> 	b) I'm not as familiar with pdmenu source - but reading, seems to
> 	   talk directly to gpm using its documented interface, and to
> 	   be using slang.

I tried to reproduce it, same issue indeed:

Program received signal SIGBUS, Bus error.
CheckMouse () at ../src/mouse.c:39
39	    FD_SET(gpm_fd, &rfds);
(gdb) bt
#0  CheckMouse () at ../src/mouse.c:39
#1  0x0000000000404072 in DoMenu (m=0x1f79d10, MenuAction=0x402c80 <Pdmenu_Action>, 
    Ctrl_C_Action=0x402ca0 <Handle_Ctrl_C>) at ../src/menu.c:336
#2  0x0000000000404e62 in main (argc=<value optimized out>, argv=0x7fff9a00ff08)
    at ../src/pdmenu.c:275
(gdb) p gpm_fd
$1 = -1

pdmenu doesn't like gpm_fd becoming -1 under its feet.

I haven't been able to reproduce the issue with w3m.

Samuel




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Sun, 12 Oct 2008 10:21:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Kurt Roeckx <kurt@roeckx.be>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Sun, 12 Oct 2008 10:21:02 GMT) Full text and rfc822 format available.

Message #140 received at 470882@bugs.debian.org (full text, mbox):

From: Kurt Roeckx <kurt@roeckx.be>
To: Samuel Thibault <samuel.thibault@ens-lyon.org>
Cc: Václav Ovsík <vaclav.ovsik@i.cz>, 470882@bugs.debian.org, Thomas Dickey <dickey@radix.net>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Sun, 12 Oct 2008 12:19:49 +0200
On Thu, Oct 09, 2008 at 01:14:28AM +0200, Samuel Thibault wrote:
> 
> Now, that being said, that reminds me bug #472063: actually libgpm
> shouldn't even have tried to connect to the server, it should have just
> noticed it is running in an X terminal and set gpm_fd to -2...

Both people reporting this bug seem to be using rxvt-unicode, and 
#472063 is also about that.  #472063 is also still open.

So I've tried a few different things.  Using aptitude:
- virtual console shows mouse, but doesn't work as expected.  Clicking
  somewhere doesn't always seem to have an effect.  Click and drag seems
  to have a weird effects.
- xterm: the mouse icon stays the same as a normal xterm, one used for
  selecting text.  Clicking someone does seem to have the desired
  effect.  However, it seems that the place where the cursor is shown
  in other cases it just shows an empty space instead of the '-'.
- rxvt-unicode: The mouse icon is also the text selecting one, and it's
  all that it seems to be doing.  The cursor is not shown.
- gnome-terminal: the mouse icon is a normal pointer.  It also works
  as expected.  When aptitude wasn't started it was the text selection
  icon.
- konsole: behaves the same as gnome-terminal.

For w3m:
- virtual console: no mouse shown, also doesn't seem to have
  any effect at all.
- xterm: same as aptitude, but text under cursor still shown.
- rxvt-unicode: same as aptitude, but the cursor is shown now.
- gnome-terminal: same as aptitude.
- konsole: same as aptitude.

For pdmenu:
- virtual console: no mouse shown, but moving it changes the current
  line of the menu.  It's shown in white on black, no colors.
- xterm, rxvt-unicode, gnome-terminal, konsole: Just selection
  of text.  They all show it in color, rxvt-unicode with a grey
  background, the rest with a blue background.


So it seems to me that the problem might be in the terminal emulator.

I was not able to reproduce any hanging or segfaults or something
simular.


Packages used:
aptitude       0.4.11.8-1
gpm            1.20.4-2
libncurses5    5.6+20080830-1
w3m            0.5.2-2+b1
rxvt-unicode   9.05-1
gnome-terminal 2.22.3-3
xterm          235-1
konsole	       4:3.5.9.dfsg.1-5





Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Sun, 12 Oct 2008 13:54:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@radix.net>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Sun, 12 Oct 2008 13:54:03 GMT) Full text and rfc822 format available.

Message #145 received at 470882@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Kurt Roeckx <kurt@roeckx.be>
Cc: Samuel Thibault <samuel.thibault@ens-lyon.org>, Václav Ovsík <vaclav.ovsik@i.cz>, 470882@bugs.debian.org, Thomas Dickey <dickey@radix.net>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Sun, 12 Oct 2008 09:52:10 -0400
[Message part 1 (text/plain, inline)]
On Sun, Oct 12, 2008 at 12:19:49PM +0200, Kurt Roeckx wrote:
> On Thu, Oct 09, 2008 at 01:14:28AM +0200, Samuel Thibault wrote:
> > 
> > Now, that being said, that reminds me bug #472063: actually libgpm
> > shouldn't even have tried to connect to the server, it should have just
> > noticed it is running in an X terminal and set gpm_fd to -2...
> 
> Both people reporting this bug seem to be using rxvt-unicode, and 
> #472063 is also about that.  #472063 is also still open.
> 
> So I've tried a few different things.  Using aptitude:
> - virtual console shows mouse, but doesn't work as expected.  Clicking
>   somewhere doesn't always seem to have an effect.  Click and drag seems
>   to have a weird effects.

ncurses is "only" using a click-style interface for GPM (no dragging).
As I recall it, GPM also has some built-in behavior for select/paste
which ncurses doesn't try to work around.

> - xterm: the mouse icon stays the same as a normal xterm, one used for
>   selecting text.  Clicking someone does seem to have the desired
>   effect.  However, it seems that the place where the cursor is shown
>   in other cases it just shows an empty space instead of the '-'.

I'm not sure why ncurses would behave different from gnome/konsole here.
The description isn't clear (to me) though...

(coincidentally, I was just testing gnome-terminal with vttest, seeing
some mouse-related bugs there ;-)

> - rxvt-unicode: The mouse icon is also the text selecting one, and it's
>   all that it seems to be doing.  The cursor is not shown.

that may depend on the terminfo (Debian maintains that one).

> - gnome-terminal: the mouse icon is a normal pointer.  It also works
>   as expected.  When aptitude wasn't started it was the text selection
>   icon.
> - konsole: behaves the same as gnome-terminal.
> 
> For w3m:
> - virtual console: no mouse shown, also doesn't seem to have
>   any effect at all.
> - xterm: same as aptitude, but text under cursor still shown.
> - rxvt-unicode: same as aptitude, but the cursor is shown now.
> - gnome-terminal: same as aptitude.
> - konsole: same as aptitude.
> 
> For pdmenu:
> - virtual console: no mouse shown, but moving it changes the current
>   line of the menu.  It's shown in white on black, no colors.
> - xterm, rxvt-unicode, gnome-terminal, konsole: Just selection
>   of text.  They all show it in color, rxvt-unicode with a grey
>   background, the rest with a blue background.
> 
> 
> So it seems to me that the problem might be in the terminal emulator.
> 
> I was not able to reproduce any hanging or segfaults or something
> simular.
> 
> 
> Packages used:
> aptitude       0.4.11.8-1
> gpm            1.20.4-2
> libncurses5    5.6+20080830-1
> w3m            0.5.2-2+b1
> rxvt-unicode   9.05-1
> gnome-terminal 2.22.3-3
> xterm          235-1
> konsole	       4:3.5.9.dfsg.1-5

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Sat, 25 Oct 2008 18:51:10 GMT) Full text and rfc822 format available.

Message #148 received at 470882@bugs.debian.org (full text, mbox):

From: Christoph Berg <myon@debian.org>
To: 470882@bugs.debian.org
Cc: Thomas Dickey <dickey@radix.net>, Kurt Roeckx <kurt@roeckx.be>, Samuel Thibault <samuel.thibault@ens-lyon.org>, Václav Ovsík <vaclav.ovsik@i.cz>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Sat, 25 Oct 2008 20:47:08 +0200
[Message part 1 (text/plain, inline)]
[http://wiki.debian.org/BugSprint is to blame for me looking into this]

As the locking occurs on exactly the 7th event (using rxvt-unicode +
pdmenu here), there must be kept some state somewhere. That's most
likely gpm.

Client applications try to connect() to /dev/gpmctl, but starting from
the 7th try, this locks up. Stracing gpm shows that it doesn't ever
accept() the connection, not on the first tries, nor later. gdb shows
it loops in wait_text() from which it never exits:

#0  0x00007f41a2a13fc0 in nanosleep () from /lib/libc.so.6
#1  0x00007f41a2a13e17 in sleep () from /lib/libc.so.6
#2  0x000000000041378a in wait_text (fdptr=0x61c2a8) at daemon/wait_text.c:38
#3  0x0000000000410172 in old_main () at daemon/old_main.c:172
#4  0x000000000040f705 in main (argc=5, argv=0x7fffab167d88) at daemon/main.c:33

The bit that would accept() connections is processConn() is never
reached because old_main() continues the loop earlier.

So far I managed to find a way to work around the problem by starting
gpm with the -F (force repeat) option:

#0  0x00007f8b5e95ec93 in select () from /lib/libc.so.6
#1  0x000000000040ff05 in old_main () at daemon/old_main.c:133
#2  0x000000000040f719 in main (argc=6, argv=0x7fff67087c98) at daemon/main.c:33

Now pdmenu doesn't lock up anymore.

I suspect the following code from old_main() is bogus:

     /* 
      * Be sure to be in text mode. This used to be before select,
      * but actually it only matters if you have events.
      */
      {
      int fd = open_console(O_RDONLY);
      if (ioctl(fd, KDGETMODE, &kd_mode) < 0)
         gpm_report(GPM_PR_OOPS,GPM_MESS_IOCTL_KDGETMODE);
      close(fd);
      if(kd_mode != KD_TEXT && !option.repeater && !option.force_repeat) {
         wait_text(&mouse_table[1].fd);

What does it mean to be "in text mode"? What if X is started later?
Does gpm assume that all X users will need to enable a repeater? Since
/dev/input/mice exists, that's no longer true, afaict.

Or is the bug rather that applications not running on a linux consule
must not try to connect to gpm? In this case, gpm should probably
still reject the connection in some way.

Christoph
-- 
cb@df7cb.de | http://www.df7cb.de/
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Sat, 25 Oct 2008 19:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Kurt Roeckx <kurt@roeckx.be>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Sat, 25 Oct 2008 19:15:03 GMT) Full text and rfc822 format available.

Message #153 received at 470882@bugs.debian.org (full text, mbox):

From: Kurt Roeckx <kurt@roeckx.be>
To: Christoph Berg <myon@debian.org>, 470882@bugs.debian.org, Thomas Dickey <dickey@radix.net>, Samuel Thibault <samuel.thibault@ens-lyon.org>, Václav Ovsík <vaclav.ovsik@i.cz>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Sat, 25 Oct 2008 21:13:29 +0200
On Sat, Oct 25, 2008 at 08:47:08PM +0200, Christoph Berg wrote:
> 
> I suspect the following code from old_main() is bogus:
> 
>      /* 
>       * Be sure to be in text mode. This used to be before select,
>       * but actually it only matters if you have events.
>       */
>       {
>       int fd = open_console(O_RDONLY);
>       if (ioctl(fd, KDGETMODE, &kd_mode) < 0)
>          gpm_report(GPM_PR_OOPS,GPM_MESS_IOCTL_KDGETMODE);
>       close(fd);
>       if(kd_mode != KD_TEXT && !option.repeater && !option.force_repeat) {
>          wait_text(&mouse_table[1].fd);
> 
> What does it mean to be "in text mode"? What if X is started later?

It return 0 (KD_TEXT) when the _current_ console is a text console
and 1 (KD_GRAPHICS) when you're in X.  It has nothing to do with
what console gpm runs on, since it's detached.



Kurt





Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Sat, 25 Oct 2008 19:30:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Kurt Roeckx <kurt@roeckx.be>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Sat, 25 Oct 2008 19:30:02 GMT) Full text and rfc822 format available.

Message #158 received at 470882@bugs.debian.org (full text, mbox):

From: Kurt Roeckx <kurt@roeckx.be>
To: Christoph Berg <myon@debian.org>, 470882@bugs.debian.org, Thomas Dickey <dickey@radix.net>, Samuel Thibault <samuel.thibault@ens-lyon.org>, Václav Ovsík <vaclav.ovsik@i.cz>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Sat, 25 Oct 2008 21:27:11 +0200
On Sat, Oct 25, 2008 at 08:47:08PM +0200, Christoph Berg wrote:
> [http://wiki.debian.org/BugSprint is to blame for me looking into this]
> 
> As the locking occurs on exactly the 7th event (using rxvt-unicode +
> pdmenu here), there must be kept some state somewhere. That's most
> likely gpm.

Restarting gpm makes it work again.

> So far I managed to find a way to work around the problem by starting
> gpm with the -F (force repeat) option:

I've always used the -R option which I probably don't need anymore,
so I guess that's why I couldn't reproduce it.

>       int fd = open_console(O_RDONLY);
>       if (ioctl(fd, KDGETMODE, &kd_mode) < 0)
>          gpm_report(GPM_PR_OOPS,GPM_MESS_IOCTL_KDGETMODE);
>       close(fd);
>       if(kd_mode != KD_TEXT && !option.repeater && !option.force_repeat) {
>          wait_text(&mouse_table[1].fd);

You know that you're looking at the code from experimental, right?


Kurt





Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Sat, 25 Oct 2008 19:36:02 GMT) Full text and rfc822 format available.

Message #161 received at 470882@bugs.debian.org (full text, mbox):

From: Christoph Berg <myon@debian.org>
To: Kurt Roeckx <kurt@roeckx.be>
Cc: 470882@bugs.debian.org, Thomas Dickey <dickey@radix.net>, Samuel Thibault <samuel.thibault@ens-lyon.org>, Václav Ovsík <vaclav.ovsik@i.cz>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Sat, 25 Oct 2008 21:34:15 +0200
[Message part 1 (text/plain, inline)]
Re: Kurt Roeckx 2008-10-25 <20081025191329.GA25136@roeckx.be>
> >       if(kd_mode != KD_TEXT && !option.repeater && !option.force_repeat) {
> >          wait_text(&mouse_table[1].fd);
> > 
> > What does it mean to be "in text mode"? What if X is started later?
> 
> It return 0 (KD_TEXT) when the _current_ console is a text console
> and 1 (KD_GRAPHICS) when you're in X.  It has nothing to do with
> what console gpm runs on, since it's detached.

That code runs in the server. wait_text() doesn't return while X is
shown on the console, and that makes the connect()s from libgpm pile
up, and finally block.

Christoph
-- 
cb@df7cb.de | http://www.df7cb.de/
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Sat, 25 Oct 2008 20:12:02 GMT) Full text and rfc822 format available.

Message #164 received at 470882@bugs.debian.org (full text, mbox):

From: Christoph Berg <myon@debian.org>
To: Kurt Roeckx <kurt@roeckx.be>
Cc: 470882@bugs.debian.org, Thomas Dickey <dickey@radix.net>, Samuel Thibault <samuel.thibault@ens-lyon.org>, Václav Ovsík <vaclav.ovsik@i.cz>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Sat, 25 Oct 2008 22:09:35 +0200
[Message part 1 (text/plain, inline)]
Re: Kurt Roeckx 2008-10-25 <20081025192711.GB25136@roeckx.be>
> >       int fd = open_console(O_RDONLY);
> >       if (ioctl(fd, KDGETMODE, &kd_mode) < 0)
> >          gpm_report(GPM_PR_OOPS,GPM_MESS_IOCTL_KDGETMODE);
> >       close(fd);
> >       if(kd_mode != KD_TEXT && !option.repeater && !option.force_repeat) {
> >          wait_text(&mouse_table[1].fd);
> 
> You know that you're looking at the code from experimental, right?

gpm (1.20.4-2) unstable; urgency=low
 -- Guillem Jover <guillem@debian.org>  Sun, 22 Jun 2008 09:38:10 +0300

Same version is also in testing.

Christoph
-- 
cb@df7cb.de | http://www.df7cb.de/
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Sat, 25 Oct 2008 20:33:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Kurt Roeckx <kurt@roeckx.be>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Sat, 25 Oct 2008 20:33:02 GMT) Full text and rfc822 format available.

Message #169 received at 470882@bugs.debian.org (full text, mbox):

From: Kurt Roeckx <kurt@roeckx.be>
To: Christoph Berg <myon@debian.org>, 470882@bugs.debian.org
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Sat, 25 Oct 2008 22:30:37 +0200
On Sat, Oct 25, 2008 at 10:09:35PM +0200, Christoph Berg wrote:
> Re: Kurt Roeckx 2008-10-25 <20081025192711.GB25136@roeckx.be>
> > >       int fd = open_console(O_RDONLY);
> > >       if (ioctl(fd, KDGETMODE, &kd_mode) < 0)
> > >          gpm_report(GPM_PR_OOPS,GPM_MESS_IOCTL_KDGETMODE);
> > >       close(fd);
> > >       if(kd_mode != KD_TEXT && !option.repeater && !option.force_repeat) {
> > >          wait_text(&mouse_table[1].fd);
> > 
> > You know that you're looking at the code from experimental, right?
> 
> gpm (1.20.4-2) unstable; urgency=low


It seems I didn't look at the source with the patches applied.


Kurt





Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Sat, 25 Oct 2008 20:42:02 GMT) Full text and rfc822 format available.

Message #172 received at 470882@bugs.debian.org (full text, mbox):

From: Christoph Berg <myon@debian.org>
To: Kurt Roeckx <kurt@roeckx.be>
Cc: 470882@bugs.debian.org
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Sat, 25 Oct 2008 22:41:12 +0200
[Message part 1 (text/plain, inline)]
Re: Kurt Roeckx 2008-10-25 <20081025203037.GA6720@roeckx.be>
> > gpm (1.20.4-2) unstable; urgency=low
> 
> It seems I didn't look at the source with the patches applied.

Btw, I had tried disabling some patches, but the result was the same.

Christoph
-- 
cb@df7cb.de | http://www.df7cb.de/
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Tue, 28 Oct 2008 01:51:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <samuel.thibault@ens-lyon.org>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Tue, 28 Oct 2008 01:51:08 GMT) Full text and rfc822 format available.

Message #177 received at 470882@bugs.debian.org (full text, mbox):

From: Samuel Thibault <samuel.thibault@ens-lyon.org>
To: Christoph Berg <myon@debian.org>, 470882@bugs.debian.org, Thomas Dickey <dickey@radix.net>, Kurt Roeckx <kurt@roeckx.be>, Václav Ovsík <vaclav.ovsik@i.cz>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Tue, 28 Oct 2008 02:50:22 +0100
Hello,

Same for me, I've always had the repeater, thus couldn't reproduce the
"7th" bug.

Christoph Berg, le Sat 25 Oct 2008 20:47:08 +0200, a écrit :
> Or is the bug rather that applications not running on a linux consule
> must not try to connect to gpm?

Ideally they shouldn't even try, yes.  And they used to not try, see bug
#472063.

> In this case, gpm should probably still reject the connection in some
> way.

Yes.  The problem is that then you get the crash whose backtrace can be
read in http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=470882#135 : it
looks like libgpm can not afford just closing its fd and setting gpm_fd
to -1 since the application could still e.g. add it to an fd_set or have
done it already (and then get a EBADF).

Samuel




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Tue, 11 Nov 2008 21:27:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <samuel.thibault@ens-lyon.org>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Tue, 11 Nov 2008 21:27:07 GMT) Full text and rfc822 format available.

Message #182 received at 470882@bugs.debian.org (full text, mbox):

From: Samuel Thibault <samuel.thibault@ens-lyon.org>
To: Christoph Berg <myon@debian.org>, 470882@bugs.debian.org, Thomas Dickey <dickey@radix.net>, Kurt Roeckx <kurt@roeckx.be>, Václav Ovsík <vaclav.ovsik@i.cz>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>, control@bugs.debian.org
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Tue, 11 Nov 2008 22:24:53 +0100
[Message part 1 (text/plain, inline)]
tags 470882 + patch
thanks

Hello,

Christoph Berg, le Sat 25 Oct 2008 20:47:08 +0200, a écrit :
> I suspect the following code from old_main() is bogus:
> 
>       if(kd_mode != KD_TEXT && !option.repeater && !option.force_repeat) {
>          wait_text(&mouse_table[1].fd);
> 
> What does it mean to be "in text mode"? What if X is started later?

As already said, that's not a problem.

> Does gpm assume that all X users will need to enable a repeater?

Precisely no.

The problem is that you both want a mouse on the text console and a
mouse in X.  The correct way is to use a repeater: gpm reads
/dev/input/mice, and repeats to X.  Now, gpm tries to play nice with X
servers that would read /dev/input/mice themselves: if a repeater is not
setup, then when not in text mode gpm closes the mouse (to let X open
it).

The unfortunate effect here is that it waits without handling clients.
The attached patch fixes that: when not in text mode, the mouse
is closed, but the select() loop continues.  I had to change the
timeout of select, I have made it 2 seconds, like the latency of the
previously-used wait_text().  That should fix the hang of clients.

Samuel
[patch-gpm (text/plain, attachment)]

Tags added: patch Request was from Samuel Thibault <samuel.thibault@ens-lyon.org> to control@bugs.debian.org. (Tue, 11 Nov 2008 21:27:11 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Wed, 12 Nov 2008 13:45:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Gerfried Fuchs <rhonda@deb.at>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Wed, 12 Nov 2008 13:45:03 GMT) Full text and rfc822 format available.

Message #189 received at 470882@bugs.debian.org (full text, mbox):

From: Gerfried Fuchs <rhonda@deb.at>
To: Samuel Thibault <samuel.thibault@ens-lyon.org>, 470882@bugs.debian.org
Cc: Christoph Berg <myon@debian.org>, Thomas Dickey <dickey@radix.net>, Kurt Roeckx <kurt@roeckx.be>, Václav Ovsík <vaclav.ovsik@i.cz>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>, control@bugs.debian.org
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Wed, 12 Nov 2008 14:43:19 +0100
* Samuel Thibault <samuel.thibault@ens-lyon.org> [2008-11-11 22:24:53 CET]:
> The problem is that you both want a mouse on the text console and a
> mouse in X.  The correct way is to use a repeater: gpm reads
> /dev/input/mice, and repeats to X.  Now, gpm tries to play nice with X
> servers that would read /dev/input/mice themselves: if a repeater is not
> setup, then when not in text mode gpm closes the mouse (to let X open
> it).
> 
> The unfortunate effect here is that it waits without handling clients.
> The attached patch fixes that: when not in text mode, the mouse
> is closed, but the select() loop continues.  I had to change the
> timeout of select, I have made it 2 seconds, like the latency of the
> previously-used wait_text().  That should fix the hang of clients.

 Are you sure with that fix? I applied it and did a local rebuild, and
now pdmenu segfaults on any keypress after starting. I don't really call
that an improvment. :)

 Just to be sure I did it properly, I dumped your patch into
debian/patches/060_eliminate-hang-in-X11 and added it to the series
file, the rebuild did happen in a current sid chroot.

 So long,
Rhonda




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Wed, 12 Nov 2008 18:36:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <samuel.thibault@ens-lyon.org>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Wed, 12 Nov 2008 18:36:02 GMT) Full text and rfc822 format available.

Message #194 received at 470882@bugs.debian.org (full text, mbox):

From: Samuel Thibault <samuel.thibault@ens-lyon.org>
To: Gerfried Fuchs <rhonda@deb.at>
Cc: 470882@bugs.debian.org, Christoph Berg <myon@debian.org>, Thomas Dickey <dickey@radix.net>, Kurt Roeckx <kurt@roeckx.be>, Václav Ovsík <vaclav.ovsik@i.cz>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>, control@bugs.debian.org
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Wed, 12 Nov 2008 19:33:19 +0100
Gerfried Fuchs, le Wed 12 Nov 2008 14:43:19 +0100, a écrit :
> > The unfortunate effect here is that it waits without handling clients.
> > The attached patch fixes that: when not in text mode, the mouse
> > is closed, but the select() loop continues.  I had to change the
> > timeout of select, I have made it 2 seconds, like the latency of the
> > previously-used wait_text().  That should fix the hang of clients.
> 
>  Are you sure with that fix?

Definitely.

> I applied it and did a local rebuild, and now pdmenu segfaults on any
> keypress after starting. I don't really call that an improvment. :)

It is: now you at least get a connexion, and get rejected.

The pdmenu segfault is due to another bug, see my mail dated 11th
October. The problem is that pdmenu tries to connect to gpm, but because
it is not running as root or as the owner of the console ttys, the
server eventually rejects it (_after_ having received some data, because
on some systems it's the only way to get the credentials), i.e. the
server closes the connection, the client gets an EOF, closes it too, and
sets gpm_fd to -1. Then pdmenu uses it in a FD_SET() call. SEGFAULT.

One way to fix it would be in the client to create a pipe, and dup2()
the read side into the gpm_fd, in order to keep the fd never readable
again. It's quite ugly, but that's the only way I can see to fix clients
that use gpm_fd without taking care. Else we have to fix all the
clients.

(Note that if gpm is restarted, you get the same issue: the client gets
an EOF etc).

Samuel




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Thu, 13 Nov 2008 00:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <samuel.thibault@ens-lyon.org>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Thu, 13 Nov 2008 00:42:03 GMT) Full text and rfc822 format available.

Message #199 received at 470882@bugs.debian.org (full text, mbox):

From: Samuel Thibault <samuel.thibault@ens-lyon.org>
To: Gerfried Fuchs <rhonda@deb.at>
Cc: 470882@bugs.debian.org, Christoph Berg <myon@debian.org>, Thomas Dickey <dickey@radix.net>, Kurt Roeckx <kurt@roeckx.be>, Václav Ovsík <vaclav.ovsik@i.cz>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>, control@bugs.debian.org
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Thu, 13 Nov 2008 01:39:03 +0100
[Message part 1 (text/plain, inline)]
clone 470882
retitle -1 pdmenu should check the value returned by Gpm_GetEvent()
reassign -1 pdmenu
thanks

Reading the documentation of Gpm_GetEvent:

« It returns 1 on success, -1 on failure, and 0 after closing the connection. »

pdmenu doesn't properly check that.  It should.  Patch attached.

Samuel
[patch (text/plain, attachment)]

Disconnected #470882 from all other report(s). Request was from Samuel Thibault <samuel.thibault@ens-lyon.org> to control@bugs.debian.org. (Thu, 13 Nov 2008 01:18:14 GMT) Full text and rfc822 format available.

Bug 470882 cloned as bug 505502. Request was from Samuel Thibault <samuel.thibault@ens-lyon.org> to control@bugs.debian.org. (Thu, 13 Nov 2008 01:18:18 GMT) Full text and rfc822 format available.

Merged 470882 476431. Request was from Samuel Thibault <samuel.thibault@ens-lyon.org> to control@bugs.debian.org. (Thu, 13 Nov 2008 01:18:27 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Sat, 22 Nov 2008 16:48:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Gerfried Fuchs <rhonda@deb.at>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Sat, 22 Nov 2008 16:48:03 GMT) Full text and rfc822 format available.

Message #210 received at 470882@bugs.debian.org (full text, mbox):

From: Gerfried Fuchs <rhonda@deb.at>
To: Samuel Thibault <samuel.thibault@ens-lyon.org>, 470882@bugs.debian.org
Cc: Christoph Berg <myon@debian.org>, Thomas Dickey <dickey@radix.net>, Kurt Roeckx <kurt@roeckx.be>, Václav Ovsík <vaclav.ovsik@i.cz>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>, control@bugs.debian.org
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Sat, 22 Nov 2008 17:44:07 +0100
* Samuel Thibault <samuel.thibault@ens-lyon.org> [2008-11-12 19:33:19 CET]:
> It is: now you at least get a connexion, and get rejected.

 Hmm, alright.

> The pdmenu segfault is due to another bug, see my mail dated 11th
> October.

 Ah, right. And aptitude does behave false here too (last two lines from
strace):

write(2, "Uncaught exception: Unable to read from stdin: Bad file descriptor\n"..., 67) = 67
exit_group(-1)      = ?

 I guess we need to clone the bug to there, too, or rather libncurses
through which it seems to use gpm, it doesn't directly depend on libgpm.

 Not sure what other applications might be affected by it and should get
addressed, too ...

 Thanks,
Rhonda




Tags removed: Request was from Ben Hutchings <ben@decadent.org.uk> to control@bugs.debian.org. (Sat, 22 Nov 2008 20:57:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Mon, 24 Nov 2008 00:18:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <samuel.thibault@ens-lyon.org>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Mon, 24 Nov 2008 00:18:02 GMT) Full text and rfc822 format available.

Message #217 received at 470882@bugs.debian.org (full text, mbox):

From: Samuel Thibault <samuel.thibault@ens-lyon.org>
To: Gerfried Fuchs <rhonda@deb.at>
Cc: 470882@bugs.debian.org, Christoph Berg <myon@debian.org>, Thomas Dickey <dickey@radix.net>, Kurt Roeckx <kurt@roeckx.be>, Václav Ovsík <vaclav.ovsik@i.cz>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>, control@bugs.debian.org
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Mon, 24 Nov 2008 01:11:20 +0100
[Message part 1 (text/plain, inline)]
clone 470882 -1
reassign -1 ncurses
retitle -1 ncurses should check the value returned by Gpm_GetEvent()
thanks

Gerfried Fuchs, le Sat 22 Nov 2008 17:44:07 +0100, a écrit :
>  Ah, right. And aptitude does behave false here too (last two lines from
> strace):
> 
> write(2, "Uncaught exception: Unable to read from stdin: Bad file descriptor\n"..., 67) = 67
> exit_group(-1)      = ?
> 
>  I guess we need to clone the bug to there, too, or rather libncurses
> through which it seems to use gpm, it doesn't directly depend on libgpm.

Ah, right, doing so with a patch.

>  Not sure what other applications might be affected by it and should get
> addressed, too ...

Well, all the rdeps :/

Samuel
[patch-ncurses-gpm (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Mon, 24 Nov 2008 00:33:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <samuel.thibault@ens-lyon.org>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Mon, 24 Nov 2008 00:33:06 GMT) Full text and rfc822 format available.

Message #222 received at 470882@bugs.debian.org (full text, mbox):

From: Samuel Thibault <samuel.thibault@ens-lyon.org>
To: Gerfried Fuchs <rhonda@deb.at>
Cc: 470882@bugs.debian.org, Christoph Berg <myon@debian.org>, Thomas Dickey <dickey@radix.net>, Kurt Roeckx <kurt@roeckx.be>, Václav Ovsík <vaclav.ovsik@i.cz>, Nico Schottelius <nico-debian-pkg-gpm-devel@schottelius.org>, control@bugs.debian.org
Subject: Re: Bug#470882: /dev/gpmctl freezes acknowledge
Date: Mon, 24 Nov 2008 01:29:17 +0100
clone 470882 -1
reassign -1 aalib
tags -1 - patch
retitle -1 aalib should check the value returned by Gpm_GetEvent()
thanks

Gerfried Fuchs, le Sat 22 Nov 2008 17:44:07 +0100, a écrit :
>  Not sure what other applications might be affected by it and should get
> addressed, too ...

aalib is affected too.

Reading the documentation of Gpm_GetEvent:

« It returns 1 on success, -1 on failure, and 0 after closing the connection. »

aalib doesn't properly check that.  It should and for instance call
gpm_uninit in that case.

Samuel




Disconnected #470882 from all other report(s). Request was from Samuel Thibault <samuel.thibault@ens-lyon.org> to control@bugs.debian.org. (Mon, 24 Nov 2008 00:36:22 GMT) Full text and rfc822 format available.

Bug 470882 cloned as bug 506717. Request was from Samuel Thibault <samuel.thibault@ens-lyon.org> to control@bugs.debian.org. (Mon, 24 Nov 2008 00:36:23 GMT) Full text and rfc822 format available.

Merged 470882 476431. Request was from Samuel Thibault <samuel.thibault@ens-lyon.org> to control@bugs.debian.org. (Mon, 24 Nov 2008 00:36:26 GMT) Full text and rfc822 format available.

Disconnected #470882 from all other report(s). Request was from Samuel Thibault <samuel.thibault@ens-lyon.org> to control@bugs.debian.org. (Mon, 24 Nov 2008 00:42:04 GMT) Full text and rfc822 format available.

Bug 470882 cloned as bug 506718. Request was from Samuel Thibault <samuel.thibault@ens-lyon.org> to control@bugs.debian.org. (Mon, 24 Nov 2008 00:42:06 GMT) Full text and rfc822 format available.

Merged 470882 476431. Request was from Samuel Thibault <samuel.thibault@ens-lyon.org> to control@bugs.debian.org. (Mon, 24 Nov 2008 00:42:10 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>:
Bug#470882; Package gpm. (Sun, 30 Nov 2008 00:03:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Viehmann <tv@beamnet.de>:
Extra info received and forwarded to list. Copy sent to Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>. (Sun, 30 Nov 2008 00:03:03 GMT) Full text and rfc822 format available.

Message #239 received at 470882@bugs.debian.org (full text, mbox):

From: Thomas Viehmann <tv@beamnet.de>
To: 470882@bugs.debian.org
Cc: rhonda@deb.at, samuel.thibault@ens-lyon.org
Subject: gpm: diff for NMU version 1.20.4-3.1
Date: Sun, 30 Nov 2008 00:57:39 +0100
tags 470882 + patch pending
thanks

Hi Peter,

I've prepared an NMU for gpm (versioned as 1.20.4-3.1) and to be
uploaded. It is Thibault's fix. Several reverse dependencies
have already been fixed and more are on the way.

Kind regards

T.

diff -u gpm-1.20.4/debian/changelog gpm-1.20.4/debian/changelog
--- gpm-1.20.4/debian/changelog
+++ gpm-1.20.4/debian/changelog
@@ -1,3 +1,12 @@
+gpm (1.20.4-3.1) unstable; urgency=low
+
+  * Non-maintainer upload.
+  * debian/patches/060_no_blocking_on_mouse_device_under_x:
+    don't block in rxvt. Closes: #470882
+    Analysis and patch by Samuel Thibault, thanks!
+
+ -- Thomas Viehmann <tv@beamnet.de>  Sat, 29 Nov 2008 23:49:55 +0100
+
 gpm (1.20.4-3) unstable; urgency=low
 
   * Remove myself from Uploaders.
diff -u gpm-1.20.4/debian/patches/series gpm-1.20.4/debian/patches/series
--- gpm-1.20.4/debian/patches/series
+++ gpm-1.20.4/debian/patches/series
@@ -16,0 +17 @@
+060_no_blocking_on_mouse_device_under_x
only in patch2:
unchanged:
--- gpm-1.20.4.orig/debian/patches/060_no_blocking_on_mouse_device_under_x
+++ gpm-1.20.4/debian/patches/060_no_blocking_on_mouse_device_under_x
@@ -0,0 +1,65 @@
+--- a/src/daemon/old_main.c	2008-11-11 22:06:41.000000000 +0100
++++ b/src/daemon/old_main.c	2008-11-11 22:06:25.000000000 +0100
+@@ -130,10 +130,8 @@
+          FD_SET(mouse_table[eventFlag].fd,&selSet);
+       }
+       else
+-         while((pending=select(maxfd+1,&selSet,NULL_SET,NULL_SET,&timeout))==0){
+-            selSet=readySet;
++         if((pending=select(maxfd+1,&selSet,NULL_SET,NULL_SET,&timeout))==0)
+             resetTimeout();
+-         } /* go on */
+ 
+       if(opt_resize) { /* did the console resize? */
+          get_console_size(&event);
+@@ -168,12 +166,24 @@
+       if (ioctl(fd, KDGETMODE, &kd_mode) < 0)
+          gpm_report(GPM_PR_OOPS,GPM_MESS_IOCTL_KDGETMODE);
+       close(fd);
+-      if(kd_mode != KD_TEXT && !option.repeater && !option.force_repeat) {
+-         wait_text(&mouse_table[1].fd);
+-         maxfd=max(maxfd,mouse_table[1].fd);
+-         readySet=connSet;
+-         FD_SET(mouse_table[1].fd,&readySet);
+-         continue; /* reselect */
++      if (!option.repeater && !option.force_repeat) {
++         if (mouse_table[1].fd >= 0 && kd_mode != KD_TEXT) {
++            /* Non-text mode, close mouse */
++            close(mouse_table[1].fd);
++            FD_CLR(mouse_table[1].fd,&readySet);
++            mouse_table[1].fd=-1;
++         } else if (mouse_table[1].fd < 0 && kd_mode == KD_TEXT) {
++            /* Back to text mode, reopen mouse */
++            if ((mouse_table[1].fd=open((mouse_table[1].opt_dev),O_RDWR))<0)
++               gpm_report(GPM_PR_OOPS,GPM_MESS_OPEN,(mouse_table[1].opt_dev));
++            else {
++               if ((mouse_table[1].m_type)->init)
++                  (mouse_table[1].m_type)=((mouse_table[1].m_type)->init)(mouse_table[1].fd, (mouse_table[1].m_type)->flags, (mouse_table[1].m_type), mouse_argc[1],
++                          mouse_argv[1]);
++               maxfd=max(maxfd,mouse_table[1].fd);
++               FD_SET(mouse_table[1].fd,&readySet);
++            }
++         }
+       }
+       }
+ 
+@@ -185,7 +195,7 @@
+ 
+       for (i=1; i <= 1+opt_double; i++) {
+          which_mouse=mouse_table+i; /* used to access options */
+-         if (FD_ISSET(which_mouse->fd,&selSet)) {
++         if (which_mouse->fd >= 0 && FD_ISSET(which_mouse->fd,&selSet)) {
+             FD_CLR(which_mouse->fd,&selSet); pending--;
+             if (processMouse(which_mouse->fd, &event, (which_mouse->m_type), kd_mode))
+                /* pass it to the client, if any
+--- a/src/headers/gpmInt.h	2008-11-11 22:01:25.000000000 +0100
++++ b/src/headers/gpmInt.h	2008-11-11 22:01:32.000000000 +0100
+@@ -33,7 +33,7 @@
+ 
+ /*....................................... old gpmCfg.h */
+ /* timeout for the select() syscall */
+-#define SELECT_TIME 86400 /* one day */
++#define SELECT_TIME 2 /* two seconds */
+ 
+ #ifdef HAVE_LINUX_TTY_H
+ #include <linux/tty.h>




Tags added: patch, pending Request was from Thomas Viehmann <tv@beamnet.de> to control@bugs.debian.org. (Sun, 30 Nov 2008 00:03:06 GMT) Full text and rfc822 format available.

Reply sent to Neil Williams <codehelp@debian.org>:
You have taken responsibility. (Sun, 30 Nov 2008 01:03:15 GMT) Full text and rfc822 format available.

Notification sent to Gerfried Fuchs <rhonda@debian.at>:
Bug acknowledged by developer. (Sun, 30 Nov 2008 01:03:16 GMT) Full text and rfc822 format available.

Message #246 received at 470882-close@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 470882-close@bugs.debian.org
Subject: Bug#470882: fixed in gpm 1.20.4-3.1
Date: Sun, 30 Nov 2008 00:47:06 +0000
Source: gpm
Source-Version: 1.20.4-3.1

We believe that the bug you reported is fixed in the latest version of
gpm, which is due to be installed in the Debian FTP archive:

gpm_1.20.4-3.1.diff.gz
  to pool/main/g/gpm/gpm_1.20.4-3.1.diff.gz
gpm_1.20.4-3.1.dsc
  to pool/main/g/gpm/gpm_1.20.4-3.1.dsc
gpm_1.20.4-3.1_amd64.deb
  to pool/main/g/gpm/gpm_1.20.4-3.1_amd64.deb
libgpm-dev_1.20.4-3.1_amd64.deb
  to pool/main/g/gpm/libgpm-dev_1.20.4-3.1_amd64.deb
libgpm2_1.20.4-3.1_amd64.deb
  to pool/main/g/gpm/libgpm2_1.20.4-3.1_amd64.deb
libgpmg1-dev_1.20.4-3.1_amd64.deb
  to pool/main/g/gpm/libgpmg1-dev_1.20.4-3.1_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 470882@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Neil Williams <codehelp@debian.org> (supplier of updated gpm package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 30 Nov 2008 01:36:31 +0100
Source: gpm
Binary: gpm libgpm2 libgpm-dev libgpmg1-dev
Architecture: source amd64
Version: 1.20.4-3.1
Distribution: unstable
Urgency: low
Maintainer: Debian GPM Team <pkg-gpm-devel@lists.alioth.debian.org>
Changed-By: Neil Williams <codehelp@debian.org>
Description: 
 gpm        - General Purpose Mouse interface
 libgpm-dev - General Purpose Mouse - development files
 libgpm2    - General Purpose Mouse - shared library
 libgpmg1-dev - transitional dummy package which can be safely removed
Closes: 470882
Changes: 
 gpm (1.20.4-3.1) unstable; urgency=low
 .
   [ Thomas Viehmann ]
   * Non-maintainer upload.
   * debian/patches/060_no_blocking_on_mouse_device_under_x:
     don't block in rxvt. Closes: #470882
     Analysis and patch by Samuel Thibault, thanks!
 .
   [ Neil Williams ]
   * clean up Makefile to allow gpm to build twice in a row in a pbuilder
     chroot (release goal)
Checksums-Sha1: 
 2a949c2c95e87d5388dbda6d007230843078b4d1 1255 gpm_1.20.4-3.1.dsc
 e34bb5236b2d05fbc85c2bb448882e9e0d737c85 89247 gpm_1.20.4-3.1.diff.gz
 7c260872f6063344f3a49e2332a3448e2be249eb 224926 gpm_1.20.4-3.1_amd64.deb
 a7929ad880aa5215d2ce227fe87bfc2f87f9725d 35298 libgpm2_1.20.4-3.1_amd64.deb
 2e3616ffa358571b3a0b444847d5ee998677e1ef 38862 libgpm-dev_1.20.4-3.1_amd64.deb
 46f8f6c660c8cff9a5adaac59476aebafa510764 23664 libgpmg1-dev_1.20.4-3.1_amd64.deb
Checksums-Sha256: 
 45ecac48573c8b3e292f5ad71fcd951cb7e70bb448e8264d0514fc422e9841c5 1255 gpm_1.20.4-3.1.dsc
 2cf0a9128ba36e9a650a8455162e0723ffc42d3772e2db83bd9e8c959fc6f9a2 89247 gpm_1.20.4-3.1.diff.gz
 a72b0308e5384b098d90891f7e012c497d91a1c5fcef35fc91399b82427bb0ab 224926 gpm_1.20.4-3.1_amd64.deb
 35902e6b5c57502436ad4bbf1c99650a78567c771cc3d0afef07669d96cc3cbc 35298 libgpm2_1.20.4-3.1_amd64.deb
 4f6ead20b3b3152524ca4c8d51263020d3f9ce9f0f14fffb909542db187646c1 38862 libgpm-dev_1.20.4-3.1_amd64.deb
 2483af94da1a4fc27818df6431d0480e986756a9a447e73fbbb3d2ef30376646 23664 libgpmg1-dev_1.20.4-3.1_amd64.deb
Files: 
 e5edc93484854e6fdd2dfee3eb0436fd 1255 misc optional gpm_1.20.4-3.1.dsc
 d083beed7e5f05f2b010a6fe552a76ba 89247 misc optional gpm_1.20.4-3.1.diff.gz
 8ec3b45925b7be55127faefb08b4c70d 224926 misc optional gpm_1.20.4-3.1_amd64.deb
 2b27ef93e91c73feca657d791d0f4bd9 35298 libs standard libgpm2_1.20.4-3.1_amd64.deb
 2f3876094ddc2b38b899b04d994de1a4 38862 libdevel optional libgpm-dev_1.20.4-3.1_amd64.deb
 6795ece5c17f5521f4944cf5b559fe85 23664 oldlibs extra libgpmg1-dev_1.20.4-3.1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkkx4HsACgkQiAEJSii8s+PIqACgo8rAo7Q5XQMsUR7FgZT2YVfr
DpcAn3xBrG/jfIaqbyUQTbkirAlCjuZL
=lFwl
-----END PGP SIGNATURE-----





Reply sent to Neil Williams <codehelp@debian.org>:
You have taken responsibility. (Sun, 30 Nov 2008 01:03:17 GMT) Full text and rfc822 format available.

Notification sent to Simon Raven <simon.raven@gmail.com>:
Bug acknowledged by developer. (Sun, 30 Nov 2008 01:03:18 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 08 Jan 2009 07:26:51 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 16:05:50 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.